/*****************************************************************/
/*                                                               */
/*   prime ver 1.00                                             */
/*                                                               */
/*   written by sentaro21                                        */
/*                                                               */
/*****************************************************************/
/*****************************************************************/
/*                                                               */
/*   CASIO fx-9860G SDK Library                                  */
/*                                                               */
/*   File name : [ProjectName].c                                 */
/*                                                               */
/*   Copyright (c) 2006 CASIO COMPUTER CO., LTD.                 */
/*                                                               */
/*****************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include "fxlib.h"
#include "fx_syscall.h"
#include "TIMER_FX2.H"


//------------------------------------------------------------------------------
int KeyCheckAC(void)		// [AC]
{
	int kcode1 = 0, kcode2 = 0, flag0 = 0;
	short unused = 0;

	if ( Bkey_GetKeyWait(&kcode1,&kcode2,KEYWAIT_HALTOFF_TIMEROFF,0,1,&unused ) == KEYREP_KEYEVENT ) {
		if ( ( kcode1 == 1 ) && (kcode2 == 1 ) ) flag0=1; // [AC] is down
	}
 	return flag0;
}

int KeyCheckEXE(void)		// [EXE]
{
	int kcode1 = 0, kcode2 = 0, flag0 = 0;
	short unused = 0;

	if ( Bkey_GetKeyWait(&kcode1,&kcode2,KEYWAIT_HALTOFF_TIMEROFF,0,1,&unused ) == KEYREP_KEYEVENT ) {
		if ( ( kcode1 == 3 ) && (kcode2 == 2 ) ) flag0=1; // [EXE] is down
	}
 	return flag0;
}

int KeyCheckPlusMinus(void)	// (-)
{
	int kcode1 = 0, kcode2 = 0, flag0 = 0;
	short unused = 0;

	if ( Bkey_GetKeyWait(&kcode1,&kcode2,KEYWAIT_HALTOFF_TIMEROFF,0,1,&unused ) == KEYREP_KEYEVENT ) {
		if ( ( kcode1 == 4 ) && (kcode2 == 2 ) ) flag0=1; // [(-)] is down
	}
 	return flag0;
}

//----------------------------------------------------------------------------------------------

double InputNumD(int x, int y, int width, double defaultNum) {		// 0123456789
	int i,j;
	char buffer[22];
	char buffer2[22];
	unsigned int key=0;
	int csrX=0,numX=0;
	int cont=1;

	for(i=1; i<21; i++) buffer[i]=' ';
	buffer[0]='\0';	
	if ( defaultNum != 0 ) {
		sprintf(buffer,"%.0f",defaultNum);
		csrX=strlen(buffer); numX=csrX;
		buffer[csrX]=' ';
	}
	buffer[width+1]='\0';

	Cursor_SetFlashMode(1);			// cursor flashing on
	if (Cursor_GetFlashStyle()<0x6) {
		Cursor_SetFlashStyle(0);	// insert mode cursor 
		Cursor_SetFlashOn(0);
		}
		else {
		Cursor_SetFlashStyle(0x10);	// overwrite mode cursor 
		Cursor_SetFlashOn(0x6);	
	}

	while (cont) {
		locate(x       ,y); Print(   (unsigned char*)buffer);
//		locate(x,y+1); sprintf(buffer2,"%d %d  S=%d",csrX,numX,Cursor_GetFlashStyle()); Print(   (unsigned char*)buffer2);
		Cursor_SetPosition(x+csrX-1,y-1);
	
		GetKey(&key);
		switch (key) {
			case KEY_CTRL_AC:
				csrX=0; numX=0;
				for(i=csrX; i<=width; i++) buffer[i]=' ';
				break;
			case KEY_CTRL_EXIT:
				cont=0; { Cursor_SetFlashMode(0); return -1 ; }
				break;
			case KEY_CTRL_EXE:
				cont=0;
				break;
			case KEY_CTRL_DEL:
				if (csrX==0) {
					if (numX>0) {
						for(i=csrX; i<numX; i++) buffer[i]=buffer[i+1];
						numX--;
					}
				}
				if (csrX>0) {
					if (Cursor_GetFlashStyle()<0x6) {	// insert mode
						for(i=csrX-1; i<width; i++) buffer[i]=buffer[i+1];
						csrX--;
						numX--;
					}
					else {								// overwrite mode
						if (csrX==numX) {
							for(i=csrX-1; i<width; i++) buffer[i]=buffer[i+1];
							csrX--;
							numX--;
						}
						else {
							for(i=csrX  ; i<width; i++) buffer[i]=buffer[i+1];
							numX--;
						}
					}
				}
				break;
			case KEY_CTRL_LEFT:
				if (csrX>0) {
					csrX--;
				}
				break;
			case KEY_CTRL_RIGHT:
				if (csrX<numX) {
					csrX++;
				}
				break;
			default:
				break;
		}
		if ( ( KEY_CHAR_0 <= key ) && ( key <= KEY_CHAR_9 ) ) {
				if (csrX<width) {
					if (csrX<numX) {
						if (Cursor_GetFlashStyle()<0x6) {
							if (numX<width) {		// insert mode
								for(i=width; i>csrX; i--) buffer[i]=buffer[i-1];
								buffer[csrX]=key;
								numX++;
								csrX++;
							}
						}
						else {				// overwrite mode
								buffer[csrX]=key;
								csrX++;
						}
					}
					else {					// new
						buffer[csrX]=key;
						csrX++; if (csrX>numX) numX=csrX;
					}
				}
		}
	}

	Cursor_SetFlashMode(0);

	return (atof(buffer));
}


void InputTest(){
	double i,j;
	char buffer[21];
	unsigned int key=0;

	Bdisp_AllClr_DDVRAM();
	locate(1,1); Print((unsigned char*)"n=");

	i=InputNumD(3,1,15,123);
	
	locate(1,3);sprintf(buffer,"n=%.0f",i); Print((unsigned char*)buffer);

	GetKey(&key);
}


double InputSub(int x, int y, double num, double Limit) {
	char buffer[21];
	locate(x,y); Print((unsigned char*)"n=");
//	locate(x+15,y); sprintf(buffer,"<%d",Limit); Print((unsigned char*)buffer);
	loop:
		num=InputNumD(x+2,y,15,num);
		if ( num<   0)  { return -1 ; }
		if ( num<  10)  { num=  10 ; goto loop; }
		if ( num>Limit) { num=Limit; goto loop; }
	locate(x+2,y); sprintf(buffer,"%.0f   ",num); Print((unsigned char*)buffer);
	return ( num );
}

//----------------------------------------------------------------------------------------------
//----------------------------------------------------------------------------------------------

#define arrays	21
#define	dMAX	4294967296.0

double default_A=0;

void PRIME_DECOMP()
{
	double A,B,C,D,J,M,X,Y;
	double Z[arrays];
	int K,L, i, s, t, csrX=1;
	char	buffer[32];
	unsigned int key=0;
	char mults[]={0xA9,0x00}; // x

	Bdisp_AllClr_DDVRAM();
	locate(1,1); Print((unsigned char*)"PRIME DECOMP add-in");
//	locate(8,4); Print((unsigned char*)"<EXIT>:QUIT");
	locate(1,2); Print((unsigned char*)"INPUT INTEGER?");
	A=InputNumD(1, 3, 15, default_A);
	if ( A <= 1 ) return;
	default_A=A;
	
	locate(1,5); Print((unsigned char*)"Calculating!");
	Bdisp_PutDisp_DD();
	
  	//  array initialize
	for(i=0; i<arrays; i++) {
		Z[i]=0;
	}

	start_timer();	// --------------------------------------
	
	C=0; D=2; X=A; K=1;

	do {
		Y=X/D;
		if ( ( C == 0 ) && ( Y < D ) ) { 
			D=X; Y=X/D;
		}
		if ( Y == floor(Y) ) { X=Y; C++; }
		else {
				if ( C ) { Z[K]=D; Z[K+1]=C; K++; K++; C=0; }
				if ( D == 2 ) { D++; } else { D++; D++; }
		}
	} while ( Y >= 1 );
	
	t=get_timer();	// --------------------------------------


	Bdisp_AllClr_DDVRAM();
	locate(1,1);sprintf(buffer,"%.0f=",A); Print((unsigned char*)buffer);
	locate(1,8);sprintf(buffer,"time=%5.3fs",(float)t/1000); Print((unsigned char*)buffer);

	J=K-2; L=2; M=0; csrX=1;

	for ( K=1; K<=J; K+=2 ) {
		if ( K>1 ) { locate(csrX,L); Print((unsigned char*)mults); csrX++; }
		if ( Z[K+1]==1 ) sprintf(buffer,"%.0f",Z[K]);
					else sprintf(buffer,"%.0f^%.0f",Z[K],Z[K+1]);
		if ( csrX+strlen(buffer) >21 ) { csrX=1; L++; if (L==8) L=2; }
		locate(csrX,L); Print((unsigned char*)buffer); csrX+=strlen(buffer);
		csrX++;
		if ( csrX>20 ) { csrX=1; L++; if (L==8) L=2; }
	}

//	locate(11,8); Print((unsigned char*)"Hit KEY RET");
	Bdisp_PutDisp_DD();

	GetKey(&key);

}
//----------------------------------------------------------------------------------------------

void PRIME_DECOMP_INT()
{
	unsigned int A,B,C,D,J,M,X,Y;
	unsigned int Z[arrays];
	int K,L, i, s, t, csrX=1;
	char	buffer[32];
	unsigned int key=0;
	char mults[]={0xA9,0x00}; // x

	ERR:
	Bdisp_AllClr_DDVRAM();
	locate(1,1); Print((unsigned char*)"PRIME DECOMP INT");
//	locate(8,4); Print((unsigned char*)"<EXIT>:QUIT");
	locate(1,2); Print((unsigned char*)"INPUT INTEGER?");
	if ( default_A > dMAX ) default_A=0;
	A=InputNumD(1, 3, 10, default_A);
	if ( A <= 1 ) return;
	if ( A > dMAX ) { default_A=A/10; goto ERR; }
	default_A=A;

	locate(1,5); Print((unsigned char*)"Calculating!");
	Bdisp_PutDisp_DD();
	
  	//  array initialize
	for(i=0; i<arrays; i++) {
		Z[i]=0;
	}

	start_timer();	// --------------------------------------
	
	C=0; D=2; X=(int)A; K=1;

	do {
		Y=X/D;
		if ( ( C == 0 ) && ( Y < D ) ) { 
			D=X; Y=X/D;
		}
		if ( X%D == 0 ) { X=Y; C++; }
		else {
				if ( C ) { Z[K]=D; Z[K+1]=C; K++; K++; C=0; }
				if ( D == 2 ) { D++; } else { D++; D++; }
		}
	} while ( Y >= 1 );
	
	t=get_timer();	// --------------------------------------


	Bdisp_AllClr_DDVRAM();
	locate(1,1);sprintf(buffer,"%u=",A); Print((unsigned char*)buffer);
	locate(1,8);sprintf(buffer,"time=%5.3fs",(float)t/1000); Print((unsigned char*)buffer);

	J=K-2; L=2; M=0; csrX=1;

	for ( K=1; K<=J; K+=2 ) {
		if ( K > 1 ) { locate(csrX,L); Print((unsigned char*)mults); csrX++; }
		if ( Z[K+1] == 1 ) sprintf(buffer,"%u",Z[K]);
					else sprintf(buffer,"%u^%u",Z[K],Z[K+1]);
		if ( csrX+strlen(buffer) > 21 ) { csrX=1; L++; if (L==8) L=2; }
		locate(csrX,L); Print((unsigned char*)buffer); csrX+=strlen(buffer);
		csrX++;
		if ( csrX > 20 ) { csrX=1; L++; if (L==8) L=2; }
	}

//	locate(11,8); Print((unsigned char*)"Hit KEY RET");
	Bdisp_PutDisp_DD();

	GetKey(&key);

}
//----------------------------------------------------------------------------------------------
//----------------------------------------------------------------------------------------------

int IsPrime(unsigned int n) {		// return   0:no prime   1: prime
	unsigned int i;

	if ( n < 2 ) return 0;
	if ( n == 2 ) return 1;
	if ( n % 2 == 0 ) return 0;

	for(i=3; i<=n/i; i+=2)
		if ( n % i == 0 ) return 0;
	return 1;
}

int IsPrimeD(double N) {			// return   0:no prime   1: prime
	double I,max;
	unsigned int n,i;

	if ( N < dMAX ) { n = (unsigned int) N;
		if ( n < 2 ) return 0;
		if ( n == 2 ) return 1;
		if ( n % 2 == 0 ) return 0;
	
		for(i=3; i<=n/i; i+=2)
			if ( n % i == 0 ) return 0;
		return 1;
	}
	else {
		if ( N < 2 ) return 0;
		if ( N == 2 ) return 1;
		if ( N == floor(N/2)*2 ) return 0;
		max=floor(sqrt(N));
		for(I=3; I<=max; I+=2) 
			if ( N == floor(N/I)*I ) return 0;
		return 1;
	}
}

//----------------------------------------------------------------------------------------------
//----------------------------------------------------------------------------------------------
void NisPRIME() {
	double A;
	int i, s, t, result;
	char	buffer[32];
	unsigned int key=0;

	Bdisp_AllClr_DDVRAM();
	locate(1,1); Print((unsigned char*)"PRIME teat  add-in");
//	locate(8,4); Print((unsigned char*)"<EXIT>:QUIT");
	locate(1,2); Print((unsigned char*)"INPUT INTEGER?");
	A=InputNumD(1, 3, 15, default_A);
	if ( A <= 0 ) return;
	default_A=A;

	locate(1,5); Print((unsigned char*)"Calculating!");
	Bdisp_PutDisp_DD();
	
	start_timer();	// --------------------------------------

	result=IsPrimeD(A);

	t=get_timer();	// --------------------------------------

	locate(1,5);
	if ( result )
		Print((unsigned char*)"Prime Number!!!");
		else
		Print((unsigned char*)"-- not Prime Number --");

	locate(1,8);sprintf(buffer,"time=%5.3fs",(float)t/1000); Print((unsigned char*)buffer);

	Bdisp_PutDisp_DD();
	GetKey(&key);

}

//----------------------------------------------------------------------------------------------
//----------------------------------------------------------------------------------------------
int skip_count;

int disp_wait(unsigned int a, unsigned int b, int s,int t) {
	char buffer[21];
	unsigned int key=0;
	
		if ( RTC_GetTicks() > skip_count+24 ) { skip_count=RTC_GetTicks();
			t=RTC_GetTicks()-s;
			locate(1,4); sprintf(buffer, "%d", a);			Print((unsigned char*)buffer);
			locate(1,5); sprintf(buffer, "%d", b);			Print((unsigned char*)buffer);
			locate(1,6); sprintf(buffer, "time=%5.2fs", (double)t/128);	Print((unsigned char*)buffer);
			Bdisp_PutDisp_DD();
			if ( KeyCheckPlusMinus() ) {
				locate(1,7); Print((unsigned char*)"EXE:Start");
				while ( 1 )  { GetKey(&key);
					if ( key == KEY_CTRL_EXE  ) {				// [EXE]
							locate(1,7); Print((unsigned char*)"(-):Stop ");
							s=RTC_GetTicks()-t; return s; }
					if ( key == KEY_CTRL_AC   ) return 0;		// [AC]
					if ( key == KEY_CTRL_EXIT ) return 0;		// [EXIT]
				}	
			}	
			if ( KeyCheckAC() ) return 0;
		}
	return s;
}
//----------------------------------------------------------------------------------------------

double default_N=0;

void NthPRIME() {
	double A;	
	unsigned int n, count=1;
	int i, s, t; 
	char	buffer[32];
	unsigned int key=0;

	ERR:
	Bdisp_AllClr_DDVRAM();
	locate(1,1); Print((unsigned char*)"N th PRIME search");
//	locate(8,4); Print((unsigned char*)"<EXIT>:QUIT");
	locate(1,2); Print((unsigned char*)"INPUT number?");
	A=InputNumD(1, 3, 10, default_N);
	if ( A <= 0 ) return;
	default_N=A;

	locate(1,7); Print((unsigned char*)"(-):Stop ");
	locate(1,8); Print((unsigned char*)"AC :Exit");
	Bdisp_PutDisp_DD();
	
	s=RTC_GetTicks();	// --------------------------------------

	if ( A==1 ) n=2;
	else {
		n=1;
		do {
			n+=2;
			if ( IsPrime(n) ) count++;
			s=disp_wait(count, n, s, t); if (s==0) return;
		} while ( count < A );
	}
	
	t=RTC_GetTicks()-s;	// --------------------------------------

	locate(1,5); Print((unsigned char*)"             ");
	locate(1,6); Print((unsigned char*)"             ");
	locate(1,7); Print((unsigned char*)"             ");
	locate(1,4); Print((unsigned char*)"th Prime Number is");
	locate(1,5);sprintf(buffer,"%d",n); Print((unsigned char*)buffer);
	locate(1,8);sprintf(buffer,"time=%5.2fs",(float)t/128); Print((unsigned char*)buffer);

	Bdisp_PutDisp_DD();
	GetKey(&key);
}

//----------------------------------------------------------------------------------------------
//----------------------------------------------------------------------------------------------

double PrevPrimeSub( double A){
	double B,N;	
	locate(1,7); Print((unsigned char*)"Calculating!          ");
	Bdisp_PutDisp_DD();
	if ( A <= 3 ) return 2;
	B=A; 
	if ( B == floor(B/2)*2 ) B++;
	for (N=B-2; N>2; N-=2) {
		if ( IsPrimeD(N) ) break;
	}
	return N;
}

double NextPrimeSub( double A){
	double B,N;
	locate(1,7); Print((unsigned char*)"Calculating!          ");
	Bdisp_PutDisp_DD();
	if ( A == 2 ) return 3;
	B=A;
	if ( B == floor(B/2)*2 ) B--;
	for (N=B+2.0; N<1000000000000000.0; N+=2.0) {
		if ( IsPrimeD(N) ) break;
	}
	return N;
}	
//----------------------------------------------------------------------------------------------
double default_M=0;

void PrevPRIME() {
	double A,B,N;
	int i, s, t;
	char	buffer[32];
	unsigned int key=0;

	Bdisp_AllClr_DDVRAM();
	locate(1,1); Print((unsigned char*)"Previous PRIME search");
//	locate(8,4); Print((unsigned char*)"<EXIT>:QUIT");
	locate(1,2); Print((unsigned char*)"INPUT INTEGER?");
	A=InputNumD(1, 3, 15, default_M);
	if ( A <= 0 ) return;
	default_M=A;

	Bdisp_PutDisp_DD();
	
	start_timer();	// --------------------------------------

	N=PrevPrimeSub(A);

	t=get_timer();	// --------------------------------------

	locate(1,4); Print((unsigned char*)"Previous Prime is");
	locate(1,5);sprintf(buffer,"%.0f",N); Print((unsigned char*)buffer);
	
	locate(13,8); Print((unsigned char*)" < EXE >");
	Bdisp_PutDisp_DD();

	B=N;
	while ( 1 )  { 
		if ( key == KEY_CTRL_EXE  ) B=N;		// [EXE]
		if ( key == KEY_CTRL_AC   ) return;		// [AC]
		if ( key == KEY_CTRL_EXIT ) return;		// [EXIT]
		if ( key == KEY_CTRL_LEFT ) {
			start_timer();	// --------------------------------------
			B=PrevPrimeSub(B);
			t=get_timer();	// --------------------------------------
		}
		if ( key == KEY_CTRL_RIGHT) {
			start_timer();	// --------------------------------------
			B=NextPrimeSub(B);
			t=get_timer();	// --------------------------------------
		}
		locate(1,6);sprintf(buffer,"%.0f  ",B); Print((unsigned char*)buffer);
		locate(1,7); Print((unsigned char*)"                      ");
		locate(1,8);sprintf(buffer,"time=%5.3fs",(float)t/1000); Print((unsigned char*)buffer);
		Bdisp_PutDisp_DD();
		GetKey(&key);
	}
}

//----------------------------------------------------------------------------------------------

void NextPRIME() {
	double A,B,N;
	int i, s, t;
	char	buffer[32];
	unsigned int key=0;

	Bdisp_AllClr_DDVRAM();
	locate(1,1); Print((unsigned char*)"Next PRIME search");
//	locate(8,4); Print((unsigned char*)"<EXIT>:QUIT");
	locate(1,2); Print((unsigned char*)"INPUT INTEGER?");
	A=InputNumD(1, 3, 15, default_M);
	if ( A <= 0 ) return;
	default_M=A;

	Bdisp_PutDisp_DD();
	
	start_timer();	// --------------------------------------

	N=NextPrimeSub(A);

	t=get_timer();	// --------------------------------------

	locate(1,5); Print((unsigned char*)"             ");
	locate(1,4); Print((unsigned char*)"Next Prime is");
	locate(1,5);sprintf(buffer,"%.0f",N); Print((unsigned char*)buffer);
	
	locate(13,8); Print((unsigned char*)" < EXE >");
	Bdisp_PutDisp_DD();
	
	B=N;
	while ( 1 )  { 
		if ( key == KEY_CTRL_EXE  ) B=N;		// [EXE]
		if ( key == KEY_CTRL_AC   ) return;		// [AC]
		if ( key == KEY_CTRL_EXIT ) return;		// [EXIT]
		if ( key == KEY_CTRL_LEFT ) {
			start_timer();	// --------------------------------------
			B=PrevPrimeSub(B);
			t=get_timer();	// --------------------------------------
		}
		if ( key == KEY_CTRL_RIGHT) {
			start_timer();	// --------------------------------------
			B=NextPrimeSub(B);
			t=get_timer();	// --------------------------------------
		}
		locate(1,6);sprintf(buffer,"%.0f  ",B); Print((unsigned char*)buffer);
		locate(1,7); Print((unsigned char*)"                      ");
		locate(1,8);sprintf(buffer,"time=%5.3fs",(float)t/1000); Print((unsigned char*)buffer);
		Bdisp_PutDisp_DD();
		GetKey(&key);
	}
}

//----------------------------------------------------------------------------------------------
//----------------------------------------------------------------------------------------------


//****************************************************************************
//  AddIn_main (Sample program main function)
//
//  param   :   isAppli   : 1 = This application is launched by MAIN MENU.
//                        : 0 = This application is launched by a strip in eACT application.
//
//              OptionNum : Strip number (0~3)
//                         (This parameter is only used when isAppli parameter is 0.)
//
//  retval  :   1 = No error / 0 = Error
//
//****************************************************************************
int AddIn_main(int isAppli, unsigned short OptionNum)
{
	unsigned int key;
	int cont=1;

	while( cont ) {
		Bdisp_AllClr_DDVRAM();
		
		locate(1,1);Print((unsigned char*)"F1:PRIME DECOMP DBL");
		locate(1,2);Print((unsigned char*)"F2:PRIME DECOMP INT");
		locate(1,3);Print((unsigned char*)"F3:PRIME Check");
		locate(1,4);Print((unsigned char*)"F4:N th PRIME");
		locate(1,5);Print((unsigned char*)"F5:Prev PRIME");
		locate(1,6);Print((unsigned char*)"F6:Next PRIME");
		GetKey(&key);
		switch (key) {
			case KEY_CTRL_F1:
				PRIME_DECOMP();			// Prime decomposition
				break;
			case KEY_CTRL_F2:
				PRIME_DECOMP_INT();		// Prime decomposition int
				break;
			case KEY_CTRL_F3:
				NisPRIME();				// N is Prime ?
				break;
			case KEY_CTRL_F4:
				NthPRIME();				// N th Prime
				break;
			case KEY_CTRL_F5:
				PrevPRIME();			// previous Prime
				break;
			case KEY_CTRL_F6:
				NextPRIME();			// next Prime
				break;
			case KEY_CTRL_VARS:
				InputTest();			// input test
				break;
			default:
				break;
		}
	}

	return 1;
}




//****************************************************************************
//**************                                              ****************
//**************                 Notice!                      ****************
//**************                                              ****************
//**************  Please do not change the following source.  ****************
//**************                                              ****************
//****************************************************************************


#pragma section _BR_Size
unsigned long BR_Size;
#pragma section


#pragma section _TOP

//****************************************************************************
//  InitializeSystem
//
//  param   :   isAppli   : 1 = Application / 0 = eActivity
//              OptionNum : Option Number (only eActivity)
//
//  retval  :   1 = No error / 0 = Error
//
//****************************************************************************
int InitializeSystem(int isAppli, unsigned short OptionNum)
{
    return INIT_ADDIN_APPLICATION(isAppli, OptionNum);
}

#pragma section

